<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">

<!--
only the last comment before <dom-module ...> appears in the documentation
-->

<!--
Material design: [Click me](https://www.google.com/design/spec/components/text-fields.html)

`template-element` is a template to be used when creating new elements.

Example:

    <template-element></template-element>
    <template-element test="test"></template-element>

### Styling
The following custom properties and mixins are available for styling:

Custom property | Description | Default
----------------|-------------|----------
`--my-custom-color` | A custom css property | `black`
`--my-mixin-name` | A custom mixin | `{}`

@demo demo/index.html


-->
<dom-module id="template-element">
  <template>
    <!-- this makes your element follow the general theme (things like fonts) -->
    <style include="reset-css"></style>

    <!-- this will allow you to use flexbox easily -->
    <!-- surf to /ts/common-elements/iron-flex-layout-attributes/index.html -->
    <style include="iron-flex-layout-attributes"></style>

    <style>
:host{display:block}:host([disabled]){color:gray}.some-class,[some-attribute],some-element{color:var(--my-custom-color, blue)}.some-class,[some-attribute],some-element{@apply (--my-mixin-name)}

</style>

    <h1>This is the template-element element!</h1>
    <paper-button raised on-click="makeDinosaur">[[someproperty]]</paper-button>

  </template>
  <script>
Polymer({is:"template-element",behaviors:[],properties:{someproperty:{type:String,value:"Hello, World!",notify:!0,reflectToAttribute:!0,observer:"_disabledChanged",readOnly:!1}},observers:[],makeDinosaur:function(egg){return alert("you clicked the button!"),egg||(egg=new Egg("velociraptor")),this.fire("made-a-dinosaur",{fromEgg:egg}),new Dinosaur(egg)},_destroyHumanity:function(){dinosaurs=new Array;for(var i=0;1e8>i;i++)dinosaurs[i]=new Dinosaur,dinosaurs[i]._killAllHumans()},created:function(){},ready:function(){},attached:function(){},detached:function(){},attributeChanged:function(name,type){}});
</script>
</dom-module>
